
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import java.util
import jpype
import jneqsim.neqsim.processSimulation.processEquipment
import jneqsim.neqsim.processSimulation.processEquipment.stream
import jneqsim.neqsim.thermo.system
import jneqsim.neqsim.util
import typing



class SimpleReservoir(jneqsim.neqsim.processSimulation.processEquipment.ProcessEquipmentBaseClass):
    @typing.overload
    def __init__(self): ...
    @typing.overload
    def __init__(self, string: str): ...
    def GORprodution(self) -> float: ...
    def addGasInjector(self, string: str) -> jneqsim.neqsim.processSimulation.processEquipment.stream.StreamInterface: ...
    def addGasProducer(self, string: str) -> jneqsim.neqsim.processSimulation.processEquipment.stream.StreamInterface: ...
    def addOilProducer(self, string: str) -> jneqsim.neqsim.processSimulation.processEquipment.stream.StreamInterface: ...
    def addWaterInjector(self, string: str) -> jneqsim.neqsim.processSimulation.processEquipment.stream.StreamInterface: ...
    def addWaterProducer(self, string: str) -> jneqsim.neqsim.processSimulation.processEquipment.stream.StreamInterface: ...
    def displayResult(self) -> None: ...
    def getGasInPlace(self, string: str) -> float: ...
    def getGasInjector(self, int: int) -> 'Well': ...
    def getGasProducer(self, int: int) -> 'Well': ...
    def getGasProductionTotal(self, string: str) -> float: ...
    def getGasProdution(self, string: str) -> float: ...
    def getLowPressureLimit(self, string: str) -> float: ...
    def getOGIP(self, string: str) -> float: ...
    def getOOIP(self, string: str) -> float: ...
    def getOilInPlace(self, string: str) -> float: ...
    @typing.overload
    def getOilProducer(self, int: int) -> 'Well': ...
    @typing.overload
    def getOilProducer(self, string: str) -> 'Well': ...
    def getOilProductionTotal(self, string: str) -> float: ...
    def getOilProdution(self, string: str) -> float: ...
    def getProductionTotal(self, string: str) -> float: ...
    def getReservoirFluid(self) -> jneqsim.neqsim.thermo.system.SystemInterface: ...
    def getTime(self) -> float: ...
    def getWaterInjector(self, int: int) -> 'Well': ...
    def getWaterProducer(self, int: int) -> 'Well': ...
    def getWaterProdution(self, string: str) -> float: ...
    @staticmethod
    def main(stringArray: typing.Union[typing.List[str], jpype.JArray]) -> None: ...
    @typing.overload
    def run(self) -> None: ...
    @typing.overload
    def run(self, uUID: java.util.UUID) -> None: ...
    @typing.overload
    def runTransient(self, double: float) -> None: ...
    @typing.overload
    def runTransient(self, double: float, uUID: java.util.UUID) -> None: ...
    def setLowPressureLimit(self, double: float, string: str) -> None: ...
    def setReservoirFluid(self, systemInterface: jneqsim.neqsim.thermo.system.SystemInterface, double: float, double2: float, double3: float) -> None: ...

class Well(jneqsim.neqsim.util.NamedBaseClass):
    @typing.overload
    def __init__(self): ...
    @typing.overload
    def __init__(self, string: str): ...
    def getGOR(self) -> float: ...
    def getStdGasProduction(self) -> float: ...
    def getStdOilProduction(self) -> float: ...
    def getStdWaterProduction(self) -> float: ...
    def getStream(self) -> jneqsim.neqsim.processSimulation.processEquipment.stream.StreamInterface: ...
    def setStream(self, streamInterface: jneqsim.neqsim.processSimulation.processEquipment.stream.StreamInterface) -> None: ...

class WellFlow(jneqsim.neqsim.processSimulation.processEquipment.TwoPortEquipment):
    def __init__(self, string: str): ...
    def getWellProductionIndex(self) -> float: ...
    @typing.overload
    def run(self) -> None: ...
    @typing.overload
    def run(self, uUID: java.util.UUID) -> None: ...
    @typing.overload
    def runTransient(self, double: float) -> None: ...
    @typing.overload
    def runTransient(self, double: float, uUID: java.util.UUID) -> None: ...
    def setInletStream(self, streamInterface: jneqsim.neqsim.processSimulation.processEquipment.stream.StreamInterface) -> None: ...
    def setWellProductionIndex(self, double: float) -> None: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("jneqsim.neqsim.processSimulation.processEquipment.reservoir")``.

    SimpleReservoir: typing.Type[SimpleReservoir]
    Well: typing.Type[Well]
    WellFlow: typing.Type[WellFlow]
